var wright = wright || {};

var wright = {
    blueprint: function (data) {
        /* Assign type, otherwise assume div */
        if (data.type != null) {
            type = data.type;
        } else {
            type = "div"
        }
        /* Create node */
        var node = document.createElement(type);
        
        /* Add element attributes */
        if (data.attribs != null && data.attribs != "") {
            for (var key in data.attribs) {
                if (data.attribs.hasOwnProperty(key)) {
                    if (key == "class") {
                        if (data.attribs[key] instanceof Array) {
                            for (var i = 0; i < data.attribs[key].length; i++) {
                                node.classList.add (data.attribs[key][i]);
                            }
                        } else {
                            node.classList.add (data.attribs[key]);
                        }
                    } else if (key == "dataset") {
                        for (var subkey in data.attribs[key]) {
                            if (data.attribs[key].hasOwnProperty(subkey)) {
                                node.dataset[subkey] = data.attribs[key][subkey];
                            }
                        }
                    } else {
                        node[key] = data.attribs[key];
                    }
                }
            }
        }
        /* Fill in content */
        if (typeof data.content == "object") {
            if (data.content instanceof Array) {
                for (var i = 0; i < data.content.length; i++) {
                    node.appendChild (this.blueprint (data.content[i]));
                }
            } else {
                node.appendChild (this.blueprint (data.content));
            }
        } else {
            node.innerHTML = data.content;
        }
        
        return node;
    },
    
    select: function (data) {
        return document.querySelectorAll (data);
    },
    
    update: function (data) {
        var element = document.querySelectorAll (selector);
        for (var i = 0; i < element.length; i++) {
            element[i].innerHTML = data.content;
        }
    }
}
function launchStreamer (e) {
    console.log ("Quality setting: " + e.target.dataset.quality);
    launchStreamerUI (e);
}
function launchStreamerUI (e) {
    var wrapper = document.getElementById ("wrapper");
        title = document.querySelector ("#title span"),
        notice = document.querySelector ("#notice span"),
        qualities = document.getElementById ("qualities");
    
    /* Add animation classes */
    title.classList.add ("quickFadeLeft");
    notice.classList.add ("quickFadeLeft");
    qualities.classList.add ("quickFadeDown");
    
    /* Update messages and add loading icon */
    setTimeout (function () {
        var wrapper = wright.select ("#wrapper");
            title = wright.select ("#title span"),
            notice = wright.select ("#notice span");
        
        
        title.update ();
        notice.update ();
        wrapper.remove ();
        wrapper.update ();
        
        wright.update ("#title span", {content: "Launching Livestreamer"});
        wright.update ("#notice span", {content: "Launching " + e.target.dataset.quality  + " stream..."});
        var ui = wright.blueprint ({
            "attribs": {
                "id": "loading",
                "class": ["loading", "quickBounce"]
            },
            "content": {
                "type": "img",
                "attribs": {
                    "src": "../img/loading.svg",
                }
            }
        });
        wrapper.appendChild (ui);
        wrapper.removeChild (qualities);
    }, 300);
    /* Remove classes and reduce clutter in DOM */
    setTimeout (function () {
        title.classList.remove ("quickFadeLeft");
        notice.classList.remove ("quickFadeLeft");
        qualities.classList.remove ("quickFadeDown");
    }, 600);
}
function saveOptions (e) {
    console.log (e.target.value);
}
