function saveOptions (self) {
    console.log (self.id + " = " + self.value);
}

var ui = wright.design ({
    "attribs": {
        "id": "wrapper",
        "class": ["group"]
    },
    "content": [
        {
            "attribs": {
                "id": "title",
                "class": ["title", "group"]
            },
            "content": {
                "type": "span",
                "content": "Options"
            }
        },
        {
            "attribs": {
                "id": "notice",
                "class": ["notice", "group"]
            },
            "content": {
                "type": "span",
                "content": "Options are immediately saved after entering them"
            }
        },
        {
            "attribs": {
                "id": "options",
                "class": ["list", "smooth", "group"]
            },
            "content": [
                {
                    "attribs": {
                        "class": ["option", "group"]
                    },
                    "content": [
                        {
                            "attribs": {
                                "class": ["info", "group"]
                            },
                            "content": {
                                "attribs": {
                                    "class": ["padding-14", "group"]
                                },
                                "content": [
                                    {
                                        "type": "label",
                                        "content": "Provider"
                                    },
                                    {
                                        "type": "span",
                                        "content": "The back-end provider for streaming."
                                    }
                                ]
                            }
                        },
                        {
                            "attribs": {
                                "class": ["setting", "group"]
                            },
                            "content": {
                                "attribs": {
                                    "class": ["padding-14", "group"]
                                },
                                "content": {
                                    "type": "select",
                                    "attribs": {
                                        "id": "provider"
                                    },
                                    "content": [
                                        {
                                            "type": "option",
                                            "attribs": {
                                                "value": "livestreamer",
                                                "selected": "selected"
                                            },
                                            "content": "livestreamer"
                                        },
                                        {
                                            "type": "option",
                                            "attribs": {
                                                "value": "yotube-dl"
                                            },
                                            "content": "yotube-dl"
                                        }
                                    ]
                                }
                            }
                        }
                    ]
                },
                {
                    "attribs": {
                        "class": ["option", "group"]
                    },
                    "content": [
                        {
                            "attribs": {
                                "class": ["info", "group"]
                            },
                            "content": {
                                "attribs": {
                                    "class": ["padding-14", "group"]
                                },
                                "content": [
                                    {
                                        "type": "label",
                                        "content": "Path"
                                    },
                                    {
                                        "type": "span",
                                        "content": "Path to livestreamer executable, leave blank to detect automatically."
                                    }
                                ]
                            }
                        },
                        {
                            "attribs": {
                                "class": ["setting", "group"]
                            },
                            "content": {
                                "attribs": {
                                    "class": ["padding-14", "group"]
                                },
                                "content": {
                                    "type": "input",
                                    "attribs": {
                                        "id": "path",
                                        "type": "text"
                                    },
                                    "content": ""
                                }
                            }
                        }
                    ]
                },
                {
                    "attribs": {
                        "class": ["option", "group"]
                    },
                    "content": [
                        {
                            "attribs": {
                                "class": ["info", "group"]
                            },
                            "content": {
                                "attribs": {
                                    "class": ["padding-14", "group"]
                                },
                                "content": [
                                    {
                                        "type": "label",
                                        "content": "Optional Arguments"
                                    },
                                    {
                                        "type": "span",
                                        "content": "You can pass livestreamer options here in the form of <code>--foo=bar,--baz=foo</code>. Check <code>livestreamer -h</code> for what is available."
                                    }
                                ]
                            }
                        },
                        {
                            "attribs": {
                                "class": ["setting", "group"]
                            },
                            "content": {
                                "attribs": {
                                    "class": ["padding-14", "group"]
                                },
                                "content": {
                                    "type": "input",
                                    "attribs": {
                                        "id": "optargs",
                                        "type": "text"
                                    },
                                    "content": ""
                                }
                            }
                        }
                    ]
                },
                {
                    "attribs": {
                        "class": ["option", "group"]
                    },
                    "content": [
                        {
                            "attribs": {
                                "class": ["info", "group"]
                            },
                            "content": {
                                "attribs": {
                                    "class": ["padding-14", "group"]
                                },
                                "content": [
                                    {
                                        "type": "label",
                                        "content": "Quality Menu"
                                    },
                                    {
                                        "type": "span",
                                        "content": "Display a quality selection window everytime livestreamer is launched."
                                    }
                                ]
                            }
                        },
                        {
                            "attribs": {
                                "class": ["setting", "group"]
                            },
                            "content": {
                                "attribs": {
                                    "class": ["padding-14", "group"]
                                },
                                "content": {
                                    "type": "input",
                                    "attribs": {
                                        "id": "menu",
                                        "type": "checkbox",
                                        "checked": "checked",
                                        "value": "true"
                                    }
                                }
                            }
                        }
                    ]
                },
                {
                    "attribs": {
                        "class": ["option", "group"]
                    },
                    "content": [
                        {
                            "attribs": {
                                "class": ["info", "group"]
                            },
                            "content": {
                                "attribs": {
                                    "class": ["padding-14", "group"]
                                },
                                "content": [
                                    {
                                        "type": "label",
                                        "content": "Stream Quality"
                                    },
                                    {
                                        "type": "span",
                                        "content": "Change the quality of the stream, options are <code>low</code>, <code>medium</code>, <code>best</code>. Only applied if quality menu is disabled."
                                    }
                                ]
                            }
                        },
                        {
                            "attribs": {
                                "class": ["setting", "group"]
                            },
                            "content": {
                                "attribs": {
                                    "class": ["padding-14", "group"]
                                },
                                "content": {
                                    "type": "input",
                                    "attribs": {
                                        "id": "quality",
                                        "type": "text"
                                    },
                                    "content": ""
                                }
                            }
                        }
                    ]
                },
                {
                    "attribs": {
                        "class": ["option", "group"]
                    },
                    "content": [
                        {
                            "attribs": {
                                "class": ["info", "group"]
                            },
                            "content": {
                                "attribs": {
                                    "class": ["padding-14", "group"]
                                },
                                "content": [
                                    {
                                        "type": "label",
                                        "content": "Context Menu"
                                    },
                                    {
                                        "type": "span",
                                        "content": "Display a context menu when you right click a page or link with options to launch a stream."
                                    }
                                ]
                            }
                        },
                        {
                            "attribs": {
                                "class": ["setting", "group"]
                            },
                            "content": {
                                "attribs": {
                                    "class": ["padding-14", "group"]
                                },
                                "content": {
                                    "type": "input",
                                    "attribs": {
                                        "id": "contextmenu",
                                        "type": "checkbox",
                                        "checked": "checked",
                                        "value": "true"
                                    }
                                }
                            }
                        }
                    ]
                }
            ]
        }
    ]
});

if (document.body != null) {
    document.body.appendChild(ui);
}

// Emit to main.js
var options = document.querySelectorAll ("#options input, #options select");
// For each add click event
for (var i = 0; i < options.length; i++) {
    // Set each field as currently saved.
    options[i].dataset.saved = true;
    // If user focus changes from field, save.
    options[i].addEventListener("change", function () {
        var self = this;
        if (self.dataset.saved == "false" || self.type == "select-one" || self.type == "checkbox" || self.type == "radio") {
            saveOptions (self);
            self.dataset.saved = "true";
        }
    }, false);
    // timer var MUST be outside addEventListener
    var timer = 0
    // If user does nothing for 2 seconds, save.
    options[i].addEventListener("keyup", function () {
        var self = this;
        
        clearTimeout (timer);
        
        if (self.dataset.saved == "true") {
            self.dataset.saved = "false";
        }
        
        timer = setTimeout (function () {
            if (self.dataset.saved == "false") {
                saveOptions (self);
                self.dataset.saved = true;
            }
        }, 2000);
    }, false);
}
